-- =============================================
-- Author:		FID.Muhajir
-- Create date: 2019-01-24
-- Description:	
-- =============================================
CREATE PROCEDURE [dbo].[SP_EDIT_RECEIVE_SUB_MANIFEST_CHECK]
	 @SubManifestNo VARCHAR(max),
	 @L_ERR INT OUTPUT
AS
BEGIN
	DECLARE
		@LINKED_SERVER VARCHAR(MAX),
		@DB_SERVER VARCHAR(MAX),
		@SQL_TEXT VARCHAR(MAX)

	BEGIN TRY
		SELECT @LINKED_SERVER = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID = 'LINKED_SERVER_SPEX'
		SELECT @DB_SERVER = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID = 'DB_SERVER_SPEX'
		
		-- Get list kanban
		IF OBJECT_ID('tempdb..#TB_T_PART_SUB_MANIFEST') IS NOT NULL
			DROP TABLE #TB_T_PART_SUB_MANIFEST

		DECLARE @TB_T_SUB_MANIFEST AS TABLE (
			 MANIFEST_NO VARCHAR(MAX)
			,RECEIVED_FLAG VARCHAR(MAX)
		)

		DECLARE @TB_T_PART_SUB_MANIFEST AS TABLE (
			 TMMIN_ORDER_NO VARCHAR(MAX)
			,MANIFEST_NO VARCHAR(MAX)
			,MANIFEST_ITEM_NO VARCHAR(MAX)
			,PART_NO VARCHAR(MAX)
			,RECEIVED_STATUS VARCHAR(MAX)
		)

		SET @SQL_TEXT = 'SELECT  MANIFEST_NO
								,RECEIVE_FLAG			
						FROM ' + @LINKED_SERVER + '.' + @DB_SERVER + '.spex.TB_R_DAILY_ORDER_MANIFEST
						WHERE 1=1 AND MANIFEST_NO IN ( SELECT items FROM dbo.FN_SPLIT('''+@SubManifestNo+''', '';'')) 
						'
										
		print @SQL_TEXT
		INSERT INTO @TB_T_SUB_MANIFEST
		EXEC (@SQL_TEXT);



		SET @SQL_TEXT = 'SELECT TMMIN_ORDER_NO
								,MANIFEST_NO
								,MANIFEST_ITEM_NO
								,PART_NO
								,RECEIVED_STATUS			
						FROM ' + @LINKED_SERVER + '.' + @DB_SERVER + '.spex.TB_R_DAILY_ORDER_PART
						WHERE 1=1 AND MANIFEST_NO IN ( SELECT items FROM dbo.FN_SPLIT('''+@SubManifestNo+''', '';'')) 
						'
										

		INSERT INTO @TB_T_PART_SUB_MANIFEST
		EXEC (@SQL_TEXT);
		

		--select * from @TB_T_SUB_MANIFEST
		--select * from @TB_T_PART_SUB_MANIFEST

		UPDATE B
		SET B.RECEIVE_FLAG = A.RECEIVED_FLAG
		FROM @TB_T_SUB_MANIFEST A JOIN TB_R_DAILY_ORDER_MANIFEST B 
			ON	A.MANIFEST_NO = B.MANIFEST_NO 

		UPDATE B
		SET B.RECEIVED_STATUS = A.RECEIVED_STATUS
		FROM @TB_T_PART_SUB_MANIFEST A JOIN TB_R_DAILY_ORDER_PART B 
			ON	A.MANIFEST_NO = B.MANIFEST_NO 
				AND A.MANIFEST_ITEM_NO = B.ITEM_NO
				AND A.PART_NO = B.PART_NO

		
		
		IF EXISTS(SELECT 1 FROM @TB_T_SUB_MANIFEST WHERE RECEIVED_FLAG = '1' )
		BEGIN
			SET @L_ERR = 1 ;
		END
		ELSE
		BEGIN
			SET @L_ERR = 0 ;
		END

	

	END TRY
	BEGIN CATCH
		SET @L_ERR = 1;
	END CATCH

	SELECT @L_ERR;
	--SELECT @MSG_TYPE + '|' + @MSG_TXT AS TEXT
END

